#include "f.hpp"
#include "dco.hpp"
#include<iostream>

template<typename T>
void f_t(const T& x_v, T& y_v, T& dydx) {
  using DCO_T=typename dco::gt1s<T>::type;
  DCO_T x,y; 
  dco::value(x)=x_v; dco::derivative(x)=1;
  f(x,y);
  y_v=dco::value(y); dydx=dco::derivative(y);
}

int main() {
  double x=1, y, dydx; 
  f_t(x,y,dydx);
  std::cout << y << std::endl
            << dydx << std::endl;
  return 0;
}
